quality/urls.py
from django.urls import path

from .views import (
    CheckFullOverview,
    CheckOverview,
    HealthCheck,
    HomePage,
    NetworkDetail,
    NetworkFullDetail,
    NetworkList,
    NetworkOverview,
    OperatorList,
    StationDetail,
)

app_name = "quality"
urlpatterns = [
    path("", HomePage.as_view(), name="homepage"),
    path("healthcheck/", HealthCheck.as_view(), name="healthcheck"),
    path("checks/", CheckOverview.as_view(), name="check-overview"),
    path("checks/full/", CheckFullOverview.as_view(), name="check-full-overview"),
    path("networks/", NetworkList.as_view(), name="network-list"),
    path("networks/<int:pk>/", NetworkDetail.as_view(), name="network-detail"),
    path("networks/<int:pk>/full/", NetworkFullDetail.as_view(), name="network-full-detail"),  # noqa: E501
    path("networks/<int:pk>/overview/", NetworkOverview.as_view(), name="network-overview"),  # noqa: E501
    path("operators/", OperatorList.as_view(), name="operator-list"),
    path("stations/<int:pk>/", StationDetail.as_view(), name="station-detail"),
]  # fmt: skip

waveqc/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", include("quality.urls")),
]

if settings.DEBUG:
    urlpatterns.append(path("__debug__/", include("debug_toolbar.urls")))

quality/forms.py
from django import forms


class MultiChoiceField(forms.TypedMultipleChoiceField):
    """
    Multichoice field inherits from MultipleChoiceField but
    doesn't check if values are valid against choices
    """

    def valid_value(self, _value: str) -> bool:
        return True


class FilterForm(forms.Form):
    year = forms.IntegerField(required=False)
    triggered = forms.NullBooleanField(required=False)
    network = MultiChoiceField(required=False, coerce=str, empty_value=None)
    station = MultiChoiceField(required=False, coerce=str, empty_value=None)
    channel = MultiChoiceField(required=False, coerce=str, empty_value=None)
    operator = MultiChoiceField(required=False, coerce=str, empty_value=None)

quality/views.py
from itertools import groupby
from typing import Any

import numpy as np
import numpy.typing as npt
import plotly.graph_objects as go
from django.core.exceptions import BadRequest
from django.db.models import Max, Min
from django.http import HttpRequest, HttpResponse
from django.urls import reverse
from django.views import View
from django.views.generic import DetailView, ListView, TemplateView
from django.views.generic.base import ContextMixin
from pendulum.date import Date
from plotly.subplots import make_subplots

from quality.forms import FilterForm

from .layouts import (
    HEATMAP_LAYOUT_COMPLETENESS,
    HEATMAP_LAYOUT_NETWORK,
    HEATMAP_LAYOUT_QUALITY,
    HEATMAP_LAYOUT_STATION,
)
from .models import (
    RESULT_PONDERATION,
    Channel,
    Check,
    Network,
    Operator,
    Station,
)
from .utils import Filter, get_rtserved_stations, get_station_last_rt_data


class HealthCheck(View):
    def get(self, _request: HttpRequest) -> HttpResponse:
        return HttpResponse("OK")


class CheckFormMixin(ContextMixin):
    def get_context_data(self, **kwargs: object) -> dict[str, object]:
        context = super().get_context_data(**kwargs)
        extra = {
            "networks": Network.objects.all(),
            "stations": Station.objects.all().order_by("code"),
            "operators": Operator.objects.checks_exist()
            .only("agency")
            .order_by("agency"),
            "channels": Channel.objects.checks_exist().instruments(),
        }
        context.update(extra)
        return context


class HomePage(CheckFormMixin, TemplateView):
    template_name = "quality/homepage.html"


class OperatorList(ListView[Operator]):
    model = Operator
    ordering = ["agency"]


class NetworkList(ListView[Network]):
    model = Network


class NetworkOverview(DetailView[Network]):
    model = Network
    template_name = "quality/network_overview.html"

    def get_context_data(self, **kwargs: object) -> dict[str, object]:
        context = super().get_context_data(**kwargs)
        query = Station.objects.overview(network_id=self.object.pk)
        context.update(
            {
                "stations": query.filter(triggered=False),
                "triggered_stations": query.filter(triggered=True),
                "rtserved": get_rtserved_stations(network=self.object.code),
            }
        )
        return context


class Heatmap(ContextMixin):
    @staticmethod
    def completeness_trace(mean: npt.NDArray[np.int8]) -> go.Heatmap:
        return go.Heatmap(
            y=[
                (f"<span id='{index}'>{completeness}%</span>")
                for index, completeness in enumerate(mean)
            ],
            z=np.expand_dims(mean, axis=1),
            **HEATMAP_LAYOUT_COMPLETENESS,
        )

    def figure(
        self,
        results: npt.NDArray[np.int8],
        items: list[str],
        dates: list[Date],
    ) -> go.Figure:
        mean = np.round(np.mean(results[:, :, 0], axis=1), 2)
        # Height = items * 15 px + padding
        minimum_height = 400
        layout_height = max(minimum_height, len(items) * 15 + 180)

        figure = make_subplots(specs=[[{"secondary_y": True}]])
        figure.add_trace(
            go.Heatmap(
                x=dates,
                y=items,
                z=results[:, :, 0] + results[:, :, 1],
                customdata=results,
                **HEATMAP_LAYOUT_NETWORK,
            ),
            secondary_y=False,
        )
        figure.add_trace(self.completeness_trace(mean), secondary_y=True)
        figure.update_layout(
            xaxis_side="top",
            height=layout_height,
        )
        return figure.to_html(full_html=False, include_plotlyjs=False)

    def get_summary(self, _filters: Filter) -> object:
        msg = "Subclass must implement abstract method"
        raise NotImplementedError(msg)

    @staticmethod
    def build_x_values(query: Any) -> list[Date]:
        return sorted({key for key, _ in groupby(query, lambda x: x[2])})

    def build_y_values(self, query: Any) -> list[str]:
        return [
            "<a href='{}?{}' target='_self'>{}.{}</a>".format(
                reverse("quality:station-detail", kwargs={"pk": pk}),
                self.request.GET.urlencode(),  # type: ignore[attr-defined]
                network,
                station,
            )
            for (pk, station, network), _ in groupby(
                query,
                lambda x: (x[1], x[0], x[7]),
            )
        ]

    @staticmethod
    def build_z_values(query: Any) -> npt.NDArray[np.int8]:
        # build z values (check results)
        # Warning : Here, we make the assumption that there is a check
        #           for channel each day
        time_to_percent_ratio = 100 / (86400 * 1000)
        return np.array(
            [
                [
                    [
                        check[3] * time_to_percent_ratio,
                        RESULT_PONDERATION[check[4]],
                        check[5],
                        check[6],
                    ]
                    for check in checks
                ]
                for _, checks in groupby(query, lambda x: x[0])
            ],
        )

    def years_available(self, _filters: Filter) -> list[int]:
        msg = "Subclass must implement abstract method"
        raise NotImplementedError(msg)

    def get_context_data(self, **kwargs: object) -> dict[str, object]:
        context = super().get_context_data(**kwargs)
        form = FilterForm(self.request.GET)  # type: ignore[attr-defined]
        if not form.is_valid():
            raise BadRequest(form.errors.as_data())
        filters: Filter = form.cleaned_data  # type: ignore[assignment]
        query = self.get_summary(filters)
        if query:
            dates = self.build_x_values(query)
            items = self.build_y_values(query)
            results = self.build_z_values(query)
            years_available = self.years_available(filters)

            context.update(
                {
                    "figure": self.figure(results=results, items=items, dates=dates),
                    "years_available": years_available,
                },
            )
        return context


class FullHeatmap(Heatmap):
    @staticmethod
    def build_y_values(query: Any) -> list[str]:
        return [
            key
            for key, _ in groupby(
                query,
                lambda x: f"{x[9]}.{x[8]}.{x[7]}.{x[1]}",
            )
        ]


class NetworkDetail(Heatmap, DetailView[Network]):
    model = Network

    def years_available(self, _filters: Filter) -> list[int]:
        dates = Check.objects.filter(
            channel__station__network_id=self.object.id,
        ).aggregate(min=Min("date"), max=Max("date"))
        return list(range(dates["min"].year, dates["max"].year + 1))

    def get_summary(self, filters: Filter) -> object:
        return (
            Station.objects.filter(network_id=self.object.pk)
            .channels(filters["channel"])
            .year(filters["year"])
            .triggered(filters["triggered"])
            .summary()
        )


class NetworkFullDetail(FullHeatmap, NetworkDetail):
    def get_summary(self, filters: Filter) -> object:
        return (
            Check.objects.filter(channel__station__network_id=self.object.pk)
            .year(filters["year"])
            .triggered(filters["triggered"])
            .summary()
        )


class CheckOverview(Heatmap, CheckFormMixin, TemplateView):
    template_name = "quality/check_overview.html"

    def years_available(self, filters: Filter) -> list[int]:
        dates = (
            Check.objects.networks(filters["network"])
            .stations(filters["station"])
            .channels(filters["channel"])
            .operators(filters["operator"])
            .triggered(filters["triggered"])
            .aggregate(min=Min("date"), max=Max("date"))
        )
        return list(range(dates["min"].year, dates["max"].year + 1))

    def get_summary(self, filters: Filter) -> object:
        return (
            Station.objects.networks(filters["network"])
            .stations(filters["station"])
            .channels(filters["channel"])
            .operators(filters["operator"])
            .year(filters["year"])
            .triggered(filters["triggered"])
            .summary()
        )


class CheckFullOverview(FullHeatmap, CheckOverview):
    def get_summary(self, filters: Filter) -> object:
        return (
            Check.objects.networks(filters["network"])
            .stations(filters["station"])
            .channels(filters["channel"])
            .operators(filters["operator"])
            .year(filters["year"])
            .triggered(filters["triggered"])
            .summary()
        )


class StationDetail(FullHeatmap, DetailView[Station]):
    model = Station
    queryset = Station.objects.all().select_related("network")

    def figure(
        self,
        results: npt.NDArray[np.int8],
        items: list[str],
        dates: list[Date],
    ) -> go.Figure:
        minimum_height = 450
        layout_height = max(minimum_height, len(items) * 60 + 200)

        mean = np.round(np.mean(results[:, :, 0], axis=1), 2)
        figure = make_subplots(
            rows=2,
            cols=1,
            shared_xaxes=True,
            specs=[[{"secondary_y": True}], [{"secondary_y": False}]],
        )
        figure.add_trace(
            go.Heatmap(
                x=dates,
                y=items,
                z=results[:, :, 0] + results[:, :, 1],
                customdata=results,
                **HEATMAP_LAYOUT_QUALITY,
            ),
            row=1,
            col=1,
            secondary_y=False,
        )
        figure.add_trace(self.completeness_trace(mean), secondary_y=True)
        # We need to know the maximum number of traces for all checks
        zmax = max(np.max(results[:, :, 2]), 4)

quality/templates/quality/check_form.html
{% load quality_extras %}

<form class="row row-cols-sm-auto g-3 align-items-center"
      method="get"
      action="{% url 'quality:check-overview' %}">
  <div class="col-12">
    <label class="visually-hidden" for="networkSelect">Networks selection</label>
    <select class="form-select form-select-sm"
            id="networkSelect"
            name="network"
            placeholder="Networks"
            multiple>
      {% for network in networks %}
        <option {% if network.code in request.GET|getlist:"network" %}selected{% endif %}
                value="{{ network.code }}">{{ network.code }}</option>
      {% endfor %}
    </select>
  </div>
  <div class="col-12">
    <label class="visually-hidden" for="stationSelect">Stations selection</label>
    <select class="form-select form-select-sm"
            id="stationSelect"
            name="station"
            placeholder="Stations"
            multiple>
      {% for station in stations %}
        <option {% if station.code in request.GET|getlist:"station" %}selected{% endif %}
                value="{{ station.code }}">{{ station.code }}</option>
      {% endfor %}
    </select>
  </div>
  <div class="col-12">
    <label class="visually-hidden" for="channelSelect">Channels selection</label>
    <select class="form-select form-select-sm"
            id="channelSelect"
            name="channel"
            placeholder="Channels"
            multiple>
      {% for channel in channels %}
        <option {% if channel in request.GET|getlist:"channel" %}selected{% endif %}
                value="{{ channel }}">{{ channel }}</option>
      {% endfor %}
    </select>
  </div>
  <div class="col-12">
    <label class="visually-hidden" for="operatorSelect">Operators selection</label>
    <select class="form-select form-select-sm"
            id="operatorSelect"
            name="operator"
            placeholder="Operators"
            multiple>
      {% for operator in operators.acronyms_only %}
        <option {% if operator in request.GET|getlist:"operator" %}selected{% endif %}
                value="{{ operator }}">{{ operator }}</option>
      {% endfor %}
    </select>
  </div>
  <div class="col-12">
    <button type="submit" class="btn btn-primary btn-sm">Submit</button>
  </div>
</form>

quality/templates/quality/check_overview.html
{% extends "base.html" %}

{% block title %}
  Checks
{% endblock title %}

{% block links %}
  <li class="breadcrumb-item">
    <a href="{% url 'quality:homepage' %}">Home</a>
  </li>
  <li class="breadcrumb-item active" aria-current="page">Filtered channels</li>
{% endblock links %}

{% block main %}
  <div class="container">

    {% block breadcrumbs %}
      {{ block.super }}
    {% endblock breadcrumbs %}

    <h1 class="h2">Heatmap for filtered channels</h1>
  </div>
  <div class="container-fluid">
    <div class="row">
      <div class="col-md-2 col-lg-2 offset-xl-1 col-xl-1">
        <div class="d-md-none">
          {% include "quality/check_form.html" %}
          <br>
        </div>
        <div class="d-none d-md-block mt-5 pt-5">{% include "quality/check_form.html" %}</div>
      </div>
      <div class="col-md-10 col-lg-10 col-xl-10">
        <article>{% include "quality/heatmap.html" %}</article>
      </div>
    </div>
  </div>
{% endblock main %}

quality/templates/quality/heatmap.html
{% block extrahead %}
  <script src="https://cdn.plot.ly/plotly-cartesian-3.0.0.min.js"></script>
{% endblock extrahead %}

<!-- Full/Summary Filter -->
{% if "stations" not in request.path %}
  <div class="btn-group btn-group-sm me-2"
       role="group"
       aria-label="include channels detail">
    {% if "checks" in request.path %}
      <a href="{% url 'quality:check-overview' %}{% querystring %}"
         type="button"
         class="btn btn-outline-secondary {% if 'full' not in request.path %}active{% endif %}">summary</a>
      <a href="{% url 'quality:check-full-overview' %}{% querystring %}"
         type="button"
         class="btn btn-outline-secondary {% if 'full' in request.path %}active{% endif %}">full</a>
    {% else %}
      <a href="{% url 'quality:network-detail' object.pk %}{% querystring %}"
         type="button"
         class="btn btn-outline-secondary {% if 'full' not in request.path %}active{% endif %}">summary</a>
      <a href="{% url 'quality:network-full-detail' object.pk %}{% querystring %}"
         type="button"
         class="btn btn-outline-secondary {% if 'full' in request.path %}active{% endif %}">full</a>
    {% endif %}
  </div>
{% endif %}
<!-- Years Filter -->
<div class="btn-group btn-group-sm me-2"
     role="group"
     aria-label="available period">
  {% for year in years_available %}
    <a href="{{ request.path }}{% querystring year=year %}"
       type="button"
       class="btn btn-outline-secondary {% if request.GET.year == year|slugify %}active{% endif %}">{{ year }}</a>
  {% endfor %}
  <a href="{{ request.path }}{% querystring year=None %}"
     type="button"
     class="btn btn-outline-secondary {% if 'year' not in request.GET.keys %}active{% endif %}">last month</a>
</div>
<!-- Triggered/Monitored/All stations filter -->
{% if "stations" not in request.path %}
  <div class="btn-group btn-group-sm me-2"
       role="group"
       aria-label="triggered or continuous stations">
    <a href="{{ request.path }}{% querystring triggered=None %}"
       type="button"
       class="btn btn-outline-secondary {% if 'triggered' not in request.GET %}active{% endif %}">All</a>
    <a href="{{ request.path }}{% querystring triggered='false' %}"
       type="button"
       class="btn btn-outline-secondary {% if request.GET.triggered == 'false' or request.GET.triggered == 'False' %}active{% endif %}">Continous</a>
    <a href="{{ request.path }}{% querystring triggered='true' %}"
       type="button"
       class="btn btn-outline-secondary {% if request.GET.triggered == 'true' or request.GET.triggered == 'True' %}active{% endif %}">Triggered</a>
  </div>
{% endif %}
{% if figure %}
  {{ figure|safe }}
{% else %}
  <br>
  No data available
{% endif %}

quality/templates/quality/homepage.html
{% extends "base.html" %}

{% block title %}
  Home Page
{% endblock title %}

{% block links %}
  <li class="breadcrumb-item active" aria-current="page">Home</li>
{% endblock links %}

{% block content %}
  <article>
    <div class="row">
      <div class="col">
        <h4>Filter channels</h4>
        {% include "quality/check_form.html" %}
        <br>
      </div>
    </div>
    <div class="row">
      <div class="col-3">
        <h4>Monitored networks</h4>
        <ul class="list-unstyled">
          {% for network in networks %}
            <li>
              <a href="{% url 'quality:network-overview' network.pk %}">{{ network.code }}</a>
            </li>
          {% endfor %}
        </ul>
      </div>
      <div class="col-6">
        <h4>Networks operators</h4>
        <ul class="list-unstyled">
          {% for operator in operators %}
            <li>
              <a href="{% url 'quality:check-overview' %}?operator={{ operator.agency }}">{{ operator.agency }}</a>
            </li>
          {% endfor %}
        </ul>
      </div>
      <div class="col-3">
        <h4>Available channels</h4>
        <ul class="list-unstyled">
          {% for channel in channels %}
            <li>
              <a href="{% url 'quality:check-overview' %}?channel={{ channel }}">{{ channel }}</a>
            </li>
          {% endfor %}
        </ul>
      </div>
    </div>
  </article>
{% endblock content %}

quality/templates/quality/network_detail.html
{% extends "base.html" %}
{% load static %}

{% block title %}
  {{ object.code }} detail
{% endblock title %}

{% block links %}
  <li class="breadcrumb-item">
    <a href="{% url 'quality:homepage' %}">Home</a>
  </li>
  <li class="breadcrumb-item">
    <a href="{% url 'quality:network-list' %}">Networks</a>
  </li>
  <li class="breadcrumb-item">
    <a href="{% url 'quality:network-overview' object.pk %}">{{ object.code }}</a>
  </li>
  {% if "full" in request.path %}
    <li class="breadcrumb-item active" aria-current="page">Full</li>
  {% else %}
    <li class="breadcrumb-item active" aria-current="page">Detail</li>
  {% endif %}
{% endblock links %}

{% block content %}
  <article>
    <h1 class="h2">Heatmap for network {{ object.code }}</h1>
    {% include "quality/heatmap.html" %}
  </article>
{% endblock content %}

quality/templates/quality/network_list.html
{% extends "base.html" %}

{% block title %}
  Networks
{% endblock title %}

{% block links %}
  <li class="breadcrumb-item">
    <a href="{% url 'quality:homepage' %}">Home</a>
  </li>
  <li class="breadcrumb-item active" aria-current="page">Networks</li>
{% endblock links %}

{% block content %}
  <article>
    <h1>Monitored networks</h1>
    <ul class="list-unstyled">
      {% for network in object_list %}
        <li>
          <a href="{% url 'quality:network-overview' pk=network.pk %}">{{ network.code }}</a>
          <br>
        </li>
      {% endfor %}
    </ul>
  </article>
{% endblock content %}

quality/templates/quality/network_overview.html
{% extends "base.html" %}
{% load quality_extras %}

{% block title %}
  {{ object.code }}
{% endblock title %}

{% block links %}
  <li class="breadcrumb-item">
    <a href="{% url 'quality:homepage' %}">Home</a>
  </li>
  <li class="breadcrumb-item">
    <a href="{% url 'quality:network-list' %}">Networks</a>
  </li>
  <li class="breadcrumb-item active" aria-current="page">{{ object.code }}</li>
  <li class="breadcrumb-item">
    <a href="{% url 'quality:network-detail' object.pk %}">Detail</a>
  </li>
{% endblock links %}

{% block content %}
  <article>
    <h1 class="h2">Stations for {{ object.code }}</h1>
    <div class="row">
      <div class="col-xl-9 col-lg-8 text-center">
        <div class="row g-2">
          <div class="d-flex flex-wrap">
            {% for station in stations %}
              <div class="flex-fill p-1">
                <a class="btn btn-outline-{{ station.result|colorize }} position-relative"
                   href="{% url 'quality:station-detail' pk=station.id %}"
                   role="button">
                  {{ station.code }}
                  {% if station.code not in rtserved %}
                    <span class="position-absolute top-0 start-100 translate-middle p-1 bg-danger border border-light rounded-circle">
                      <span class="visually-hidden">No real time data</span>
                    </span>
                  {% endif %}
                </a>
              </div>
            {% empty %}
              No checks have been run these last 7 days for this network
            {% endfor %}
          </div>
        </div>
        {% if triggered_stations %}
          <br>
          <h4>Triggered stations in this network</h4>
          <div class="row g-2">
            <div class="d-flex flex-wrap">
              {% for station in triggered_stations %}
                <div class="flex-fill p-1">
                  <a class="btn btn-outline-{{ station.result|colorize }} position-relative"
                     href="{% url 'quality:station-detail' pk=station.id %}"
                     role="button">
                    {{ station.code }}
                    {% if station.code not in rtserved %}
                      <span class="position-absolute top-0 start-100 translate-middle p-1 bg-danger border border-light rounded-circle">
                        <span class="visually-hidden">No real time data</span>
                      </span>
                    {% endif %}
                  </a>
                </div>
              {% endfor %}
            </div>
          </div>
        {% endif %}
      </div>
      <div class="col-xl-3 col-lg-4">
        <h4>Legend</h4>
        <dl class="row g-2">
          <dt class="col-lg-3 col-2">
            <a class="btn btn-outline-success" role="button">XXXX</a>
          </dt>
          <dd class="col-lg-9 col-10">
            All data are present the last 7 days
          </dd>
          <dt class="col-lg-3 col-2">
            <a class="btn btn-outline-warning" role="button">XXXX</a>
          </dt>
          <dd class="col-lg-9 col-10">
            All data are present the last 7 days but some metadata seems wrong or missing
          </dd>
          <dt class="col-lg-3 col-2">
            <a class="btn btn-outline-danger" role="button">XXXX</a>
          </dt>
          <dd class="col-lg-9 col-10">
            At least one day of data is missing in the last 7 days
          </dd>
          <dt class="col-lg-3 col-2">
            <a class="btn btn-outline-secondary position-relative" role="button">XXXX
              <span class="position-absolute top-0 start-100 translate-middle p-1 bg-danger border border-light rounded-circle">
                <span class="visually-hidden">No real time data</span>
              </span>
            </a>
          </dt>
          <dd class="col-lg-9 col-10">
            A small red button on the top right corner indicates that there is no real time data being served
          </dd>
        </dl>
      </div>
    </div>
  </article>
{% endblock content %}

quality/templates/quality/operator_list.html
{% extends "base.html" %}

{% block title %}
  Operators
{% endblock title %}

{% block links %}
  <li class="breadcrumb-item">
    <a href="{% url 'quality:homepage' %}">Home</a>
  </li>
  <li class="breadcrumb-item active" aria-current="page">Operators</li>
{% endblock links %}

{% block content %}
  <article>
    <h1>Networks operators</h1>
    <ul class="list-unstyled">
      {% for operator in object_list %}
        <li>
          <a href=''>{{ operator.agency }}</a>
        </li>
      {% endfor %}
    </ul>
  </article>
{% endblock content %}

quality/templates/quality/station_detail.html
{% extends "base.html" %}
{% load humanize %}

{% block title %}
  {{ object.code }}
{% endblock title %}

{% block links %}
  <li class="breadcrumb-item">
    <a href="{% url 'quality:homepage' %}">Home</a>
  </li>
  {% if request.META.HTTP_REFERER %}
    {% if "operators" in request.META.HTTP_REFERER %}
      <li class="breadcrumb-item">
        <a href="{% url 'quality:operator-list' %}">Operators</a>
      </li>
    {% elif "networks" in request.META.HTTP_REFERER %}
      <li class="breadcrumb-item">
        <a href="{% url 'quality:network-list' %}">Networks</a>
      </li>
      <li class="breadcrumb-item">
        <a href="{% url 'quality:network-detail' pk=object.network.id %}">{{ object.network.code }}</a>
      </li>
    {% endif %}
  {% endif %}
  <li class="breadcrumb-item active" aria-current="page">Station {{ object.code }}</li>
{% endblock links %}

{% block content %}
  <article>
    <h1 class="h2">Station {{ object.code }}</h1>
    {% include "quality/heatmap.html" %}
    <h4>Last data available on realtime server</h4>
    {% for nslc, last_seen in last_data.items %}
      <span class="badge text-bg-light small">{{ nslc }}</span> : {{ last_seen|naturaltime }}
      <br>
    {% empty %}
      A long time ago
    {% endfor %}
  </article>
{% endblock content %}